## wml 2.32.0~ds1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
PROJECT(wml)

INCLUDE ("${CMAKE_SOURCE_DIR}/cmake/shlomif_common_bootstrap.cmake")
SHLOMIF_COMMON_SETUP("${private_mod_path}")
INCLUDE ("${CMAKE_SOURCE_DIR}/cmake/thewml.cmake")
# see - http://www.cmake.org/Wiki/CMake_FAQ#Is_there_an_option_to_produce_more_.27verbose.27_compiling.3F
# SET(CMAKE_VERBOSE_MAKEFILE ON)

SET (CPU_ARCH "" CACHE STRING "A specific CPU architecture to pass to gcc")
option (OPTIMIZATION_OMIT_FRAME_POINTER "Use -fomit-frame-pointer with gcc (not recommended for debugging)")
SET (PKGDATADIR_SUBDIR "wml")
SET (RELATIVE_PKGDATADIR "${RELATIVE_DATADIR}/${PKGDATADIR_SUBDIR}")
SET (PKGDATADIR "${DATADIR}/${PKGDATADIR_SUBDIR}")

SET(VERSION "2.32.0")

IF (NOT CMAKE_INSTALL_PREFIX)
    MESSAGE (FATAL_ERROR "CMAKE_INSTALL_PREFIX must be defined. Specify it with -DCMAKE_INSTALL_PREFIX=...")
ENDIF (NOT CMAKE_INSTALL_PREFIX)

INCLUDE(GNUInstallDirs)

SET (WML_LIB_DIR_BASE "${CMAKE_INSTALL_LIBDIR}")
set (p "${CMAKE_INSTALL_PREFIX}/")
string(FIND "${WML_LIB_DIR_BASE}" "${p}" _pos)
IF("${_pos}" EQUAL "0")
    string(LENGTH "${p}" _l)
    string(SUBSTRING "${WML_LIB_DIR_BASE}" "${_l}" -1 WML_LIB_DIR_BASE)
ENDIF()

SET (WML_LIB_DIR "${WML_LIB_DIR_BASE}/wml")
SET (WML_DATA_DIR "${PKGDATADIR}/data")
SET (WML_LIBEXE_DIR "${WML_LIB_DIR}/exec/")

# This is the equivalent to perform a "make dist"/"make distdir" etc.
SET(CPACK_PACKAGE_NAME "wml")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Website Meta Language")
SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")

# Process and extract the version number.
# FILE( READ "ver.txt" VERSION)

CHOMP (VERSION)

STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET (base_with_ver "${CPACK_PACKAGE_NAME}-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_IGNORE_FILES
    "~$"
    "/\\\\.tidyall\\\\.d/"
    "/t/t/.*\\\\.exe$"
    "/tags$"
)

IF(WIN32 AND NOT UNIX)
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backlasshes.
    # SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}\\\\dondorf-king.bmp")
    SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\wml.exe")
    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\thewml.github.io")
    SET(CPACK_NSIS_URL_INFO_ABOUT "${CPACK_NSIS_HELP_LINK}")
    SET(CPACK_NSIS_DISPLAY_NAME "Website Meta Language")
    SET(CPACK_NSIS_CONTACT "shlomif@cpan.org")
    SET(CPACK_NSIS_MODIFY_PATH ON)
    # Setting for NSIS :
    SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\wml.ico")
    SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_NSIS_MODIFY_PATH "ON")
ELSE()
    # SET(CPACK_STRIP_FILES "")
    # SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF()

SET(CPACK_PACKAGE_EXECUTABLES
    "wml" "Website Meta Language Frontend"
)

FIND_PROGRAM(_lynx NAMES "lynx")
IF (NOT _lynx)
    MESSAGE (FATAL_ERROR "lynx is required - please install it.")
ENDIF ()

INCLUDE (CPack)

SET (CPAN_MODULES_TO_CHECK
    "Bit::Vector"
    "Carp::Always"
    "Class::XSAccessor"
    "File::Which"
    "GD"
    "Getopt::Long"
    "Image::Size"
    "List::MoreUtils"
    "Path::Tiny"
    "Term::ReadKey"
    "Time::HiRes"
    )

CHECK_FOR_MULTIPLE_PERL_MODULES(${CPAN_MODULES_TO_CHECK})

ENABLE_TESTING()

FUNCTION(RUN_ASC2C src dest varname)
    ADD_CUSTOM_COMMAND(
        COMMAND ${PERL_EXECUTABLE} ${CMAKE_SOURCE_DIR}/scripts/asc2c-new.pl "${src}" "${dest}" "${varname}"
        OUTPUT "${dest}.c"
        DEPENDS "${src}"
    )
ENDFUNCTION()

ADD_SUBDIRECTORY( wml_aux )
ADD_SUBDIRECTORY( wml_backend )
ADD_SUBDIRECTORY( wml_docs )
ADD_SUBDIRECTORY( wml_frontend )
ADD_SUBDIRECTORY( wml_test )
ADD_SUBDIRECTORY( wml_include )
ADD_SUBDIRECTORY( wml_misc )

=== wml_aux/CMakeLists.txt ===
ADD_SUBDIRECTORY( iselect )
ADD_SUBDIRECTORY( htmlinfo )
ADD_SUBDIRECTORY( map2html )
ADD_SUBDIRECTORY( freetable )

=== wml_docs/CMakeLists.txt ===
SET (STDS
    "wml_barebone"
    )

SET (WML_DOCS
    "wml_intro"
    "wml_tutorial"
    "wml_macros"
    "wml_faq"
    "wml_tags"
)

FOREACH(MYSTD ${STDS})
    SET (TXT_SRC "${MYSTD}.txt")
    SET (MAN7_LOCAL "${MYSTD}.7")

    # MESSAGE (FATAL_ERROR "${CMAKE_CURRENT_BINARY_DIR}/${MAN7_LOCAL}")
    ADD_COPY_TARGET("std_copy_${MYSTD}" "${CMAKE_CURRENT_SOURCE_DIR}/${TXT_SRC}" "${CMAKE_CURRENT_BINARY_DIR}/${MAN7_LOCAL}")

    INSTALL_CAT_MAN("${MAN7_LOCAL}" "7")

ENDFOREACH(MYSTD ${STDS})

# MESSAGE (FATAL_ERROR "CUR_BIN = ${CMAKE_CURRENT_BINARY_DIR}")
SET (TAGS_POD "${CMAKE_CURRENT_BINARY_DIR}/wml_tags.pod")
ADD_CUSTOM_COMMAND(
    OUTPUT "${TAGS_POD}"
    COMMAND ${PERL_EXECUTABLE}
    ARGS "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.pod.pl"
        "--src" "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.pod.in"
        "--dest" "${TAGS_POD}"
        "--main" "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.main"
        "--incl" "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.incl"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.pod.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.main"
            "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.incl"
    VERBATIM
)

# The custom command needs to be assigned to a target.
ADD_CUSTOM_TARGET(
    ${TARGET_NAME} ALL
    DEPENDS ${TAGS_POD}
)

SET (pod_dests )

FOREACH(MYDOC ${WML_DOCS})
    SET (POD_SRC "${MYDOC}.pod")
    SET (MAN_LOCAL "${MYDOC}")

    IF (${MYDOC} STREQUAL "wml_tags")
        SET (POD2MAN_SOURCE_IS_IN_BINARY 1)
    ENDIF (${MYDOC} STREQUAL "wml_tags")
    INST_POD2MAN("pod_dests" "${POD_SRC}" "${MAN_LOCAL}" "7")
ENDFOREACH(MYDOC ${WML_DOCS})

ADD_CUSTOM_TARGET(
    "docs_pods" ALL
    DEPENDS ${pod_dests}
)

=== wml_frontend/CMakeLists.txt ===
SET (username "unknown")

EXECUTE_PROCESS(COMMAND "whoami"
    OUTPUT_VARIABLE username
)

CHOMP(username)

EXECUTE_PROCESS(COMMAND "${PERL_EXECUTABLE}"
    "-MPOSIX" "-e" "print strftime('%Y-%m-%d', localtime())"
    OUTPUT_VARIABLE date
)

MACRO(set_vars)
    SET (destbase "${cmd}.pl")
    SET (dest "${CMAKE_CURRENT_BINARY_DIR}/${destbase}")
    SET (srcbase "${cmd}.src")
    SET (src "${CMAKE_CURRENT_SOURCE_DIR}/${srcbase}")
    SET (mannamebase "${cmd}")
    SET (manname "${CMAKE_CURRENT_BINARY_DIR}/${mannamebase}")
ENDMACRO(set_vars)

SET (pod_dests )


FOREACH (cmd wmk wml wmb wmd wmu wml-params-conf)
    set_vars()
    # MESSAGE( FATAL_ERROR "WML_LIB_DIR = ${WML_LIB_DIR}")
    # IF ("${cmd}" STREQUAL "wml-params-conf")
    SET(PREPROCESS_PATH_PERL__ARGS "--discardpod=0")
    PREPROCESS_PATH_PERL_WITH_FULL_NAMES("preprocess_perl_frontend_${cmd}" "${src}" "${dest}")
    SET(PREPROCESS_PATH_PERL__ARGS )
    INSTALL (
        PROGRAMS "${dest}"
        DESTINATION "${CMAKE_INSTALL_BINDIR}"
        RENAME "${cmd}"
        )
    SET (POD2MAN_SOURCE_IS_IN_BINARY "1")
    INST_POD2MAN("pod_dests" "${destbase}" "${mannamebase}" "1")
ENDFOREACH(cmd)

FOREACH(cmd wmd_missing)
    set_vars()
    INST_POD2MAN("pod_dests" "${srcbase}" "${mannamebase}" "1")
ENDFOREACH(cmd)

ADD_CUSTOM_TARGET(
    "frontend_pods" ALL
    DEPENDS ${pod_dests}
)

SET(dest_wmd_text "${CMAKE_CURRENT_BINARY_DIR}/wmd.txt")
EXECUTE_PROCESS(COMMAND "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/update-wmd.pl"
    "--output" "${dest_wmd_text}"
    "--input" "${CMAKE_CURRENT_SOURCE_DIR}/wmd.txt"
    "--version" "${VERSION}"
    "--date" "03-Sep-2020"
)
INSTALL_DATA ("${dest_wmd_text}")

=== wml_include/CMakeLists.txt ===
SET (myfiles
    all
    des/all
    des/gfont
    des/imgbg
    des/imgdot
    des/lowsrc
    des/navbar
    des/preload
    des/rollover
    des/space
    des/typography
    fmt/all
    fmt/isolatin
    fmt/pod
    fmt/sdf
    fmt/text
    fmt/url
    fmt/verbatim
    fmt/xtable
    imp/all
    imp/csmap
    imp/fsview
    imp/generic
    mod/all
    mod/MakeMaker
    mod/version
    std/all
    std/box
    std/case
    std/grid
    std/href
    std/info
    std/label
    std/lang
    std/logo
    std/page
    std/tags
    std/toc
    sup/all
    sup/hextriple
    sup/path
    sys/all
    sys/bootp3
    sys/bootp4
    sys/compat1
)

CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/sys/bootp3.src.in"
    "${CMAKE_CURRENT_BINARY_DIR}/sys/bootp3.src"
    COPYONLY
)

SET (dirs_to_make )
SET (preproc_target_dests )
SET (include_pods_dests )
SET (batch_list )

FOREACH (base ${myfiles})

    # Make the directory to which the file belongs.
    STRING (REGEX REPLACE "/.*" "" basedir "${base}")
    LIST (FIND dirs_to_make "${basedir}" found)
    IF ("${found}" STREQUAL "-1")
        LIST (APPEND dirs_to_make "${basedir}")
        FILE (MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${basedir}")
    ENDIF ("${found}" STREQUAL "-1")

    SET (destbase "${base}.wml")
    SET (dest "${CMAKE_CURRENT_BINARY_DIR}/${destbase}")
    SET (srcbase "${base}.src")
    IF ("${base}" STREQUAL "sys/bootp3")
        SET (src "${CMAKE_CURRENT_BINARY_DIR}/${srcbase}")
        SET (is_binary 1)
        # MESSAGE (FATAL_ERROR "src = ${src}")
    ELSE ("${base}" STREQUAL "sys/bootp3")
        SET (src "${CMAKE_CURRENT_SOURCE_DIR}/${srcbase}")
        SET (is_binary )
    ENDIF ("${base}" STREQUAL "sys/bootp3")
    SET (mannamebase "${base}")
    SET (manname "${CMAKE_CURRENT_BINARY_DIR}/${mannamebase}")

    STRING (REPLACE "/" "__" target_base "${base}")


    ADD_CUSTOM_COMMAND(
        OUTPUT "${dest}"
        COMMAND "${PERL_EXECUTABLE}"
        ARGS "${CMAKE_CURRENT_SOURCE_DIR}/preprocess-perl-source.pl"
            "--input" "${src}"
            "--output" "${dest}"
        DEPENDS "${src}"
    )
    LIST (APPEND batch_list "${src}" "${dest}")
    LIST (APPEND preproc_target_dests "${dest}")
    INSTALL (
        FILES "${dest}"
        DESTINATION "${PKGDATADIR}/include/"
        RENAME "${destbase}"
    )
    STRING (REPLACE "/" "::" dest_man "wml/${base}")

    IF (is_binary)
        SET (POD2MAN_SOURCE_IS_IN_BINARY 1)
    ENDIF (is_binary)
    INST_RENAME_POD2MAN(
        "include_pods_dests"
        "${srcbase}"
        "${mannamebase}"
        "3"
        "${dest_man}"
    )
ENDFOREACH()
EXECUTE_PROCESS(COMMAND "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/batch-preprocess-perl-source.pl" ${batch_list})

FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/TheWML/Frontends/Wml/")
PREPROCESS_PATH_PERL_WITH_FULL_NAMES("preprocess_perl_include_config" "${CMAKE_CURRENT_SOURCE_DIR}/TheWML/Config.pm.src" "${CMAKE_CURRENT_BINARY_DIR}/TheWML/Config.pm")
INSTALL (
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/TheWML/Config.pm"
    DESTINATION "${PKGDATADIR}/TheWML"
)
FOREACH( fn
        "TheWML/Backends/ASubst/Main.pm"
        "TheWML/Backends/Divert/Main.pm"
        "TheWML/Backends/Fixup/Main.pm"
        "TheWML/Backends/HtmlStrip/Main.pm"
        "TheWML/Backends/IPP/Args.pm"
        "TheWML/Backends/IPP/Delimit.pm"
        "TheWML/Backends/IPP/File.pm"
        "TheWML/Backends/IPP/Line.pm"
        "TheWML/Backends/IPP/Main.pm"
        "TheWML/Backends/IPP/Map.pm"
        "TheWML/Backends/Slice/Main.pm"
        "TheWML/CmdLine/Base.pm"
        "TheWML/CmdLine/IO.pm"
        "TheWML/Frontends/Wml/OptD.pm"
        "TheWML/Frontends/Wml/PassObj.pm"
        "TheWML/Frontends/Wml/PassesManager.pm"
        "TheWML/Frontends/Wml/Protect.pm"
        "TheWML/Frontends/Wml/Runner.pm"
        "TheWML/Frontends/Wml/Util.pm"
        "TheWML/Frontends/Wml/WmlRc.pm"
        "TheWML/Frontends/Wml/WmlRcDir.pm"
        )
    get_filename_component(_dir "${fn}" DIRECTORY)
    INSTALL(
        FILES "${fn}"
        DESTINATION "${PKGDATADIR}/${_dir}"
    )
ENDFOREACH()

ADD_CUSTOM_TARGET(
    "preprocess_perl_includes" ALL
    DEPENDS ${preproc_target_dests}
)

ADD_CUSTOM_TARGET(
    "includes_pods" ALL
    DEPENDS ${include_pods_dests}
)

=== wml_misc/CMakeLists.txt ===
SET (LOGO_FILES
    logo-apache.gif
    logo-apache.info
    logo-apache.png
    logo-freebsd.gif
    logo-freebsd.info
    logo-freebsd.png
    logo-gimp.gif
    logo-gimp.info
    logo-gimp.png
    logo-linux.gif
    logo-linux.info
    logo-linux.png
    logo-netbsd.gif
    logo-netbsd.info
    logo-netbsd.png
    logo-openbsd.gif
    logo-openbsd.info
    logo-openbsd.png
    logo-php.gif
    logo-php.info
    logo-php.png
    logo-vim.gif
    logo-vim.info
    logo-vim.png
    logo-wml.gif
    logo-wml.info
    logo-wml.png
)

INSTALL(
    FILES
        ${LOGO_FILES}
    DESTINATION
        "${WML_DATA_DIR}/logos"
)

=== wml_test/CMakeLists.txt ===
SET (_test_cmd_cmd_line "${PERL_EXECUTABLE}"
    "${CMAKE_CURRENT_SOURCE_DIR}/run_test.pl"
)

ADD_TEST(
    NAME wml_tests
    COMMAND ${_test_cmd_cmd_line}
)

ADD_CUSTOM_TARGET(
    "check"
    ${_test_cmd_cmd_line}
    VERBATIM
)

=== wml_backend/p1_ipp/CMakeLists.txt ===
DEFINE_WML_PERL_BACKEND("ipp" "wml_p1_ipp")

=== wml_backend/p6_asubst/CMakeLists.txt ===
DEFINE_WML_PERL_BACKEND("asubst" "wml_p6_asubst")

=== wml_backend/p8_htmlstrip/CMakeLists.txt ===
DEFINE_WML_PERL_BACKEND("htmlstrip" "wml_p8_htmlstrip")

=== wml_backend/p9_slice/CMakeLists.txt ===
SET(BASENAME "slice")
SET(src "${CMAKE_CURRENT_SOURCE_DIR}/${BASENAME}_main.pl")
SET(destbase "${BASENAME}.pl")
SET(dest "${CMAKE_CURRENT_BINARY_DIR}/${destbase}")

SET (yytab_base "SliceTermParser.pm")

SET (yytab "${CMAKE_CURRENT_SOURCE_DIR}/${yytab_base}")
# Workaround for git clone SNAFU.
EXECUTE_PROCESS(
    COMMAND "cmake" "-E" "touch_nocreate" "${yytab}"
)

ADD_CUSTOM_COMMAND(
    OUTPUT "${yytab}"
    COMMAND "pbyacc"
    ARGS "-l" "-P" "SliceTermParser" "slice_term.y"
    COMMAND "${PERL_EXECUTABLE}"
    ARGS "-i" "-lp" "./process-SliceTerm.pl" "./SliceTermParser.pm"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/slice_term.y"
)

INSTALL (
    FILES "${yytab}"
    DESTINATION "${PKGDATADIR}"
)

PREPROCESS_PATH_PERL_WITH_FULL_NAMES(
    "${BASENAME}_preproc" "${src}" "${dest}"
)

SET(INST_BASE "wml_p9_${BASENAME}")

SET (POD2MAN_SOURCE_IS_IN_BINARY)
SET (pod_dests )
INST_RENAME_POD2MAN(
    "pod_dests" "${BASENAME}.pod" "${BASENAME}" "1" "${INST_BASE}"
)

ADD_CUSTOM_TARGET(
    "${BASENAME}_pod" ALL
    DEPENDS ${pod_dests} ${yytab}
)

INSTALL(
    PROGRAMS "${dest}"
    DESTINATION "${WML_LIBEXE_DIR}"
    RENAME "${INST_BASE}"
)

=== debian/changelog ===
wml (2.32.0~ds1-1) unstable; urgency=medium

  * New upstream release
    + Drop libio-all-perl from Depends and Build-Depends.
  * Drop all occurrences of ancient lintian overrides for
    package-contains-broken-symlink.
  * Override spare-manual-page for WML passes and one more occurrence of
    package-contains-documentation-outside-usr-share-doc (file is data).
  * Declare compliance with Debian Policy 4.5.1. (No changes needed.)

 -- Axel Beckert <abe@debian.org>  Sun, 29 Nov 2020 08:53:57 +0100

wml (2.30.0~ds1-1) unstable; urgency=medium

  [ Axel Beckert ]
  * Update or explicitly declare forwarding state of most patches.
  * debian/copyright: Drop already or from 2.30.0 onwards no more existing
    files from "Files-Excluded".
  * Import new upstream release 2.30.0.
    + Drop patches applied upstream: fix-typos-found-by-lintian.patch,
      wml-fmt-text-txt2html.diff, fix-unicode-handling-in-htmlstrip.patch,
      fix-spelling-errors.diff, change-national-encoding-to-utf-8.patch
    + Drop all hunks changing "SEEALSO" to "SEE ALSO" (applied upstream).
    + Refresh remaining patches as needed.
  * Override package-contains-documentation-outside-usr-share-doc for
    non-info files sporting the .info file suffix.
  * Bump perl build-dependency to ≥ 5.14. (Actually necessary since the
    2.8.0 upstream release.)
  * Drop the alternative (formerly transitional) build-dep on lynx-cur.

  [ Antoni Villalonga ]
  * Remove remaining "ln -i" on d/rules.

 -- Axel Beckert <abe@debian.org>  Wed, 02 Sep 2020 19:19:35 +0200

=== debian/control ===
Source: wml
Section: web
Priority: optional
Maintainer: Axel Beckert <abe@debian.org>
Standards-Version: 4.5.1
Build-Depends: cmake,
               debhelper-compat (= 13),
               eperl <!nocheck>,
               freetable <!nocheck>,
               libbit-vector-perl,
               libclass-xsaccessor-perl,
               libcarp-always-perl,
               libcode-tidyall-perl <!nocheck>,
               libfile-which-perl,
               libgd-gd2-perl,
               libhtml-clean-perl,
               libimage-size-perl,
               liblist-moreutils-perl,
               libpath-tiny-perl,
               libperl-critic-perl <!nocheck>,
               libterm-readkey-perl,
               linklint <!nocheck>,
               lynx,
               m4 <!nocheck>,
               mp4h <!nocheck>,
               perl (>= 5.14.0),
               txt2html <!nocheck>,
               weblint-perl <!nocheck>,
               zlib1g-dev
Homepage: https://www.shlomifish.org/open-source/projects/website-meta-language/
Vcs-Browser: https://salsa.debian.org/debian/wml
Vcs-Git: https://salsa.debian.org/debian/wml.git
Rules-Requires-Root: no

Package: wml
Architecture: all
Depends: eperl (>= 2.2.14-2),
         libclass-xsaccessor-perl,
         libcarp-always-perl,
         libfile-which-perl,
         libimage-size-perl,
         liblist-moreutils-perl,
         libpath-tiny-perl,
         libterm-readkey-perl,
         m4 (>= 1.4-8),
         mp4h (>= 1.1.1-1),
         slice (>= 2.20),
         ${misc:Depends},
         ${perl:Depends}
Recommends: iselect (>= 1.2.0-2),
            libgd-perl,
            libhtml-clean-perl (>= 0.7-3),
            linklint,
            tidy (>= 19990415-1),
            txt2html
Suggests: freetable,
          imagemagick,
          libwww-perl,
          perl-tk,
          shtool (>= 1.5.1-1),
          tardy,
          w3-recs,
          weblint-perl
Description: off-line HTML generation toolkit
 WML (Website META Language) is a free and extensible Webdesigner's
 off-line HTML generation toolkit for Unix.  WML consists of a control
 frontend driving up to nine backends in a sequential pass-oriented
 filtering scheme. Each backend provides one particular core language.
 For maximum power WML additionally ships with a well-suited set of
 include files which provide higher-level features build on top of the
 backends core languages. While not trivial and idiot proof WML provides
 most of the core features real hackers always wanted for HTML
 generation.
 .
 iselect is needed for wmd, the WML Documentation browser. The
 remaining recommended or suggested packages are needed by optional
 passes or libraries.

Package: slice
Homepage: https://github.com/thewml/website-meta-language/tree/master/src/wml_backend/p9_slice#readme
Architecture: all
Depends: libbit-vector-perl,
         libclass-xsaccessor-perl,
         libpath-tiny-perl,
         perl,
         ${misc:Depends},
         ${perl:Depends}
Breaks: wml (<< 2.28.0~ds1-2)
Replaces: wml (<< 2.28.0~ds1-2)
Description: Extract out pre-defined slices of an ASCII file
 The slice program reads an input file and divide its prepared ASCII contents
 into possibly overlapping slices. These slices are determined by enclosing
 blocks which are defined by begin and end delimiters which have to be
 already in the file. The final output gets calculated by a slice term
 consisting of slice names, set theory operators and optional round brackets.

=== debian/rules ===
#!/usr/bin/make -f

SHELL = /bin/sh

r = $(shell pwd)/debian/wml
t = $(shell pwd)/debian/tmp
o = $(shell pwd)/obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
m = $(t)/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
p = wml

# Repackaging variables
DEBIAN_REVISION := $(shell echo -n `head -1 debian/changelog | sed -e 's/^.*(\(.*\)).*$$/\\1/'`)
DEBIAN_VERSION := $(shell echo -n $(DEBIAN_REVISION) | sed -e 's/-.*//')
UPSTREAM_VERSION := $(shell echo -n $(DEBIAN_VERSION) | sed -e 's/ds[0-9]$$//')
UPSTREAM_DIR := "$(t)/wml-$(UPSTREAM_VERSION)"
DEBIAN_DIR := "$(t)/wml-$(UPSTREAM_VERSION).orig"

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_INSTALL_DIR=dummy

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	cp -pvr wml_test/t $(o)/wml_test/
	mkdir -pv $(o)/wml_test/tests/installation/lib/wml/exec/
	ln -vs $(o)/wml_test/tests/installation/lib $(o)/wml_test/tests/installation/share
	mkdir -pv $(o)/wml_test/tests/installation/bin/
	for i in $(o)/wml_frontend/*.pl; do \
	    cp -pv $$i $(o)/wml_test/tests/installation/bin/`basename $$i .pl`; \
	done
	cp -pv $(o)/wml_backend/p1_ipp/ipp.pl             $(o)/wml_test/tests/installation/lib/wml/exec/wml_p1_ipp
	cp -pv $(o)/wml_backend/p5_divert/divert.pl       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p5_divert
	cp -pv $(o)/wml_backend/p6_asubst/asubst.pl       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p6_asubst
	cp -pv $(o)/wml_backend/p7_htmlfix/htmlfix.pl     $(o)/wml_test/tests/installation/lib/wml/exec/wml_p7_htmlfix
	cp -pv $(o)/wml_backend/p8_htmlstrip/htmlstrip.pl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p8_htmlstrip
	cp -pv $(o)/wml_backend/p9_slice/slice.pl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p9_slice
	mkdir -pv $(o)/wml_test/tests/installation/lib/perl5/include/ $(o)/wml_test/tests/installation/share/wml/include/
	cp -pvr wml_include/TheWML/ $(o)/wml_test/tests/installation/lib/perl5/
	cp -pv wml_backend/p9_slice/SliceTermParser.pm  $(o)/wml_test/tests/installation/lib/perl5/
	cp -pvr $(o)/wml_include/TheWML/ $(o)/wml_test/tests/installation/lib/perl5/
	cp -pvr $(o)/wml_include/???/ $(o)/wml_include/all.wml $(o)/wml_test/tests/installation/share/wml/include/
	#dh_auto_install -- prefix=$(o)/wml_test/tests/installation/
	ln -vs /usr/bin/mp4h  $(o)/wml_test/tests/installation/lib/wml/exec/wml_p2_mp4h
	ln -vs /usr/bin/eperl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p3_eperl
	ln -vs /usr/bin/m4    $(o)/wml_test/tests/installation/lib/wml/exec/wml_p4_gm4
	sed -e 's:^\(my $$EXEC_DIR *=\).*:\1 "$(o)/wml_test/tests/installation/lib/wml/exec";:g; s:/usr/\(lib\|share\)/wml:$(o)/wml_test/tests/installation/\1/wml:g; s:\(WML_LOC_.*\)=/usr:\1=$(o)/wml_test/tests/installation:g;' \
	    -i $(o)/wml_test/tests/installation/bin/wm? \
	       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p* \
	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*.pm \
	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*/*.pm \
	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*/*/*.pm
	dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install -- prefix=$(t)/usr mandir=$(t)/usr/share/man INSTALLDIRS=perl
	# Install icons for wml::std::logo
	dh_auto_install -Dwml_misc -- libdir=$(t)/usr/share/wml

	find $(t)/usr -type f -name .packlist -delete
	find $(t) -type d -empty -delete
	mv -v $(m)/wml/exec $(t)/usr/share/wml/
	#   Fix documentation
	for f in $(t)/usr/share/man/*/*; do \
	   sed -e 's|.*/\([^/	]*\)	.*/\([^/	]*\)|s/\2/\1/|' debian/wml.links |\
	   sed -f - $$f > $$f.new && mv -v $$f.new $$f; \
	done
	rmdir -v $(m)/wml $(m) $(t)/usr/lib
	# Don't ship wmu nor its man pages, its useless in distro (and deprecated anyways)
	rm -f $(t)/usr/share/man/man1/wmu.1* $(t)/usr/bin/wmu

	# Install slice as /usr/bin/slice instead of /usr/share/wml/exec/wml_p9_slice
	mv -v $(t)/usr/share/wml/exec/wml_p9_slice $(t)/usr/bin/slice
	mv -v $(t)/usr/share/man/man1/wml_p9_slice.1 $(t)/usr/share/man/man1/slice.1

override_dh_install:
	dh_install
	chmod 755 $(r)/usr/share/wml/contrib/tkwmd

override_dh_installdocs:
	dh_installdocs
	find $(r) '(' -name '*.spec' -o -name '*.spec.in' ')' -delete

override_dh_perl:
	dh_perl usr/lib/wml/perl/lib

########################################################
### The remainder is just the get-orig-source target ###
########################################################
get-orig-source:
	# Prepare repackaging directory
	rm -rf $(t)
	mkdir -p $(t)
	# Unpack tar ball as downloaded by uscan(1)
	tar xvj -C $(t) -f ../wml_$(UPSTREAM_VERSION).orig.tar.bz2
	# Rename directory
	mv -v $(UPSTREAM_DIR) $(DEBIAN_DIR)

	# We don't want upstream VCS stuff in our orig.tar.bz2
	-find $(DEBIAN_DIR) -name .svn -exec rm -rvf '{}' ';'

	# Also remove stuff which should not belong in the upstream
	# distribution files either.
	find $(DEBIAN_DIR) -name '*~' -exec rm -vf '{}' ';'
	find $(DEBIAN_DIR) -name '*.tmp' -exec rm -rvf '{}' ';'

	# Remove stuff which will be removed by make distclean anyway
	find $(DEBIAN_DIR) -mindepth 1 -name '*.orig' -exec rm -rvf '{}' ';'
	rm -rvf $(DEBIAN_DIR)/wml_backend/p2_mp4h/autom4te.cache

	# Remove non-free stuff
	rm -vf $(DEBIAN_DIR)/wml_docs/wml_std_*.txt
	rm -vf $(DEBIAN_DIR)/wml_docs/wml_barebone.txt

	# This was maybe not the brightest idea, if one wants to
	# switch to dh-autoreconf...
	find $(DEBIAN_DIR) -name 'configure.in' -exec rm -vf '{}' ';'

	# Remove all embedded code copies not needed to build the
	# Debian package.
	rm -vf $(DEBIAN_DIR)/config/aclocal.m4
	rm -vf $(DEBIAN_DIR)/config/configure*
	rm -vf $(DEBIAN_DIR)/config/prep_modules_files.sh
	rm -rvf $(DEBIAN_DIR)/wml_aux/freetable
	rm -rvf $(DEBIAN_DIR)/wml_aux/txt2html
	rm -rvf $(DEBIAN_DIR)/wml_aux/htmlclean
	rm -rvf $(DEBIAN_DIR)/wml_aux/iselect
	rm -rvf $(DEBIAN_DIR)/wml_aux/linklint
	rm -rvf $(DEBIAN_DIR)/wml_aux/tidy
	rm -rvf $(DEBIAN_DIR)/wml_aux/weblint
	rm -rvf $(DEBIAN_DIR)/wml_backend/p2_mp4h
	rm -rvf $(DEBIAN_DIR)/wml_backend/p3_eperl
	rm -rvf $(DEBIAN_DIR)/wml_backend/p4_gm4
	rm -rvf $(DEBIAN_DIR)/wml_backend/p9_slice
	rm -rvf $(DEBIAN_DIR)/wml_common/bitvector
	rm -rvf $(DEBIAN_DIR)/wml_common/gd/libgd
	rm -rvf $(DEBIAN_DIR)/wml_common/getoptlong
	rm -rvf $(DEBIAN_DIR)/wml_common/imagesize
	rm -rvf $(DEBIAN_DIR)/wml_common/io
	rm -rvf $(DEBIAN_DIR)/wml_common/htmlclean
	rm -rvf $(DEBIAN_DIR)/wml_common/termreadkey
	# Do not remove wml_test for now.

	# Pack the Debian Source
	tar cv -C $(t) -f ../wml_$(DEBIAN_VERSION).orig.tar \
		wml-$(UPSTREAM_VERSION).orig
	bzip2 -9vf ../wml_$(DEBIAN_VERSION).orig.tar

	# Clean up again
	rm -rf $(t)

=== debian/watch ===
version=4
opts="dversionmangle=s/~?ds\d+$//, oversionmangle=s/$/~ds1/" \
https://github.com/thewml/website-meta-language/releases .*/wml-(.*)\.tar.xz
